<?php
function unitrack_tracker() {
  $args = func_get_args();
  $op = empty($args[0]) ? 'track' : $args[0];
  $new_visitor = FALSE;
  $new_session = FALSE;
  
  switch ($op) {
    case 'nojs.png':
      drupal_set_header('Content-Type: image/png');
      echo file_get_contents(drupal_get_path('module', 'unitrack') . '/nojs.png');
      $fout = fopen('/tmp/unitrack', 'a');
      fwrite($fout, time() . ' ' . print_r($_SERVER, 1) . print_r($_SESSION, 1) . print_r($_REQUEST, 1) . "\r\n");
      fclose($fout);
      return;
      break;
    case 'action':
    default:
      $visitor_id = 0;
      $visitor_data = array();      
      $out = array();
      $existing = '';      // Retrieve user data if present.
      if (empty($_REQUEST['vid']) && !empty($_COOKIE['visitor_id'])) {
        $_REQUEST['vid'] = $_COOKIE['visitor_id'];
      }
      if (!empty($_REQUEST['vid'])) {
        $splitted = explode(',', $_REQUEST['vid']);
        // Try to validate against session.
        if (!empty($_SESSION['unitrack']['visitor']) && $_SESSION['unitrack']['visitor'] == $_REQUEST['vid']) {
          $visitor_id = intval($splitted[0]);
          $vuuid = $splitted[1];
          if (!empty($_SESSION['unitrack']['visitor_data'])) {
            $out['visitor_data'] = $_SESSION['unitrack']['visitor_data'];
          }
          else {
            $out['visitor_data'] = array();
          }
          $visitor_data = $out['visitor_data'];
        }
        elseif (count($splitted) == 2) {
          $visitor_id = intval($splitted[0]);
          if ($visitor_id > 0) {
            $q = db_select('unitrack_visitors', 'v')
              ->condition('vid', $visitor_id)
              ->fields('v', array('uuid', 'data'))
              ->execute();
            $existing = $q->fetchAssoc();
          
            // Recreate old visitor.
            if (empty($existing) && preg_match('/[0-9a-z]{8}-[0-9a-z]{4}-[0-9a-z]{4}-[0-9a-z]{4}-[0-9a-z]{12}/', $splitted[1])) {
              _unitrack_query_queue(db_insert('unitrack_visitors')
                ->fields(array('vid' => $visitor_id, 'uuid' => $splitted[1], 'created' => REQUEST_TIME, 'updated' => REQUEST_TIME)));
              $existing = array('vid' => $visitor_id, 'uuid' => $splitted[1]);
            }
          }
          if (!empty($existing['data'])) {
            $visitor_data = unserialize($existing['data']);
            if (!$visitor_data) {
              $visitor_data = array();
            }
          }
          else {
            $visitor_data = array();
          }
          $vuuid = $splitted[1];
        }
      }      
      if ($visitor_id <= 0) {
        list($visitor_id, $vuuid) = unitrack_new_visitor();
        $new_visitor = TRUE;
      }
      $out['visitor'] = $visitor_id . ',' . $vuuid;
      $session_id = 0; // Retrieve session data if present.
      if (!empty($_REQUEST['sid'])) {
        $splitted = explode(',', $_REQUEST['sid']);
        // Try to validate against session.
        if (!empty($_SESSION['unitrack']['session']) && $_SESSION['unitrack']['session'] == $_REQUEST['sid']) {
          $session_id = intval($splitted[0]);
          $suuid = $splitted[1];
        }
        elseif (count($splitted) == 2) {
          $session_id = intval($splitted[0]);
          if ($session_id > 0) {
            $existing = db_select('unitrack_sessions', 's')
              ->condition('sid', $session_id)
              ->fields('s', array('uuid'))
              ->execute()
              ->fetchField();
          }
          if ($existing != $splitted[1]) {
            $existing == '';
            $session_id = 0;
          }
          else {
            $suuid = $splitted[1];
          }
        }
      }
      if ($session_id <= 0) {
        list($session_id, $suuid) = unitrack_new_session($visitor_id, $_POST);
        $new_session = TRUE;
      }
      $out['session'] = $session_id . ',' . $suuid;
      // Modules should return only changed key/value pairs to minimize memory consumption.
      $additions = module_invoke_all('unitrack', $out);
      if (is_array($additions) && is_array($visitor_data) && count($additions)) {
        $visitor_data = array_merge($visitor_data, $additions);
        $serialized = serialize($visitor_data);
        _unitrack_query_queue(db_update('unitrack_visitors')
          ->fields(array('updated' => REQUEST_TIME, 'data' => $serialized))
          ->condition('vid', $visitor_id)  
        );
        _unitrack_query_queue(db_update('unitrack_sessions')
          ->fields(array('session_end' => REQUEST_TIME, 'data' => $serialized))
          ->condition('sid', $session_id)  
        );
      }
      else {
        _unitrack_query_queue(db_update('unitrack_visitors')
          ->fields(array('updated' => REQUEST_TIME))
          ->condition('vid', $visitor_id)  
        );
        _unitrack_query_queue(db_update('unitrack_sessions')
          ->fields(array('session_end' => REQUEST_TIME))
          ->condition('sid', $session_id)  
        );
      }
      if ($visitor_data) {
        $out['visitor_data'] = $visitor_data;
      }
      _unitrack_session_data($out);
      drupal_add_http_header('Content-type', 'text/javascript');
      echo drupal_json_encode($out);
      $request_type = empty($_REQUEST['type']) ? 'Page View' : check_plain($_REQUEST['type']);
      _unitrack_query_queue(db_insert('unitrack_actions')
        ->fields(array('sid' => $session_id, 'type' => _unitrack_type_id($request_type), 
          'address' => $_REQUEST['path'], 'timestamp' => REQUEST_TIME)));
      register_shutdown_function('_unitrack_write_db');        
  }
  
  $workers_loaded = $_SESSION['unitrack_loaders'];
  $defaults = array(
    'workers' => array('self'),
  );
}

function unitrack_generate_uuid() {
  // The field names refer to RFC 4122 section 4.1.2.
  $uuid = sprintf('%04x%04x-%04x-4%03x-%04x-%04x%04x%04x', 
    mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
    mt_rand(0, 65535), // 16 bits for "time_mid"
    mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
    bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)),'01', 6, 2)), // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
    // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
    // 8 bits for "clk_seq_low"
    mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node"
    );
  return $uuid; 
}

// Return array 
function unitrack_new_visitor($set_cookie = TRUE) {
  $uuid = unitrack_generate_uuid();
  $vid = db_insert('unitrack_visitors')
   ->fields(array(
     'uuid' => $uuid,
     'created' => REQUEST_TIME,
     'updated' => REQUEST_TIME,
   ))
   ->execute();
  if ($set_cookie && (empty($_COOKIE['unitrack_vid']) || $_COOKIE['unitrack_vid'] != "$vid,$uuid")) {
    setcookie('unitrack_vid', "$vid,$uuid", time() + 8640000, '/', $GLOBALS['cookie_domain']);
    $_COOKIE['unitrack_vid'] = "$vid,$uuid";
  }
  return array($vid, $uuid);
}

function unitrack_new_session($visitor_id, $data, $set_cookie = TRUE) {
  $uuid = unitrack_generate_uuid();
  $data['ua'] = isset($data['ua']) ? substr($data['ua'],0,250) : 'unknown';
  $data['resolution'] = isset($data['resolution']) ? $data['resolution'] : 'unknown';
  $data['os'] = isset($data['os']) ? $data['os'] : 'unknown';
  $data['flash_version'] = isset($data['flash_version']) ? $data['flash_version'] : 'unknown';
  $data['js_enabled'] = isset($data['js_enabled']) ? intval($data['js_enabled']) : (-1);
  $data['java_enabled'] = isset($data['java_enabled']) ? intval($data['java_enabled']) : (-1);
  $data['dom_storage'] = isset($data['dom_storage']) ? intval($data['dom_storage']) : (-1);
  $data['cookie'] = isset($data['cookie']) ? intval($data['cookie']) : (-1);
  if (key_exists('HTTP_X_REAL_IP', $_SERVER)) {
    $ip = $_SERVER['HTTP_X_REAL_IP'];
  } elseif (key_exists('HTTP_X_FORWARDED_FOR', $_SERVER)) {
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
  } elseif(isset($_SERVER['REMOTE_ADDR'])) {
    $ip = $_SERVER['REMOTE_ADDR'];
  }
  $data['ip'] = isset($data['ip']) ? $data['ip'] : $ip;
  $sid = db_insert('unitrack_sessions')
   ->fields(array(
     'vid' => $visitor_id,
     'uuid' => $uuid,
     'session_start' => REQUEST_TIME,
     'session_end' => REQUEST_TIME,
     'user_agent' => $data['ua'],
     'resolution' => $data['resolution'],
     'os' => $data['os'], 
     'flash_version' => $data['flash_version'], 
     'js_enabled' => $data['js_enabled'], 
     'java_enabled' => $data['java_enabled'],
     'dom_storage' => $data['dom_storage'],
     'java_enabled' => $data['java_enabled'],
     'ip' => $data['ip'],
   ))
   ->execute();
    
  if ($set_cookie && (empty($_COOKIE['unitrack_sid']) || $_COOKIE['unitrack_sid'] != "$sid,$uuid")) {
    setcookie('unitrack_sid', "$sid,$uuid", 0, '/', $GLOBALS['cookie_domain']);
    $_COOKIE['unitrack_sid'] = "$sid,$uuid";
  }
  
  return array($sid, $uuid);
}

/**
 * Shutdown function
 */
function _unitrack_write_db() {
  header('Connection:close');
  ignore_user_abort();
  ob_end_flush();
  flush();  
  // Store waiting queries to DB
  $queue = _unitrack_query_queue();
  foreach ($queue as $query) {
    $query->execute();
  }
}
